### 获取Dict中的数据值
```python
def get_dict_value(dict:Dict,key,default_value = None):
    if key not in dict.keys():
        return default_value
    return dict[key]
```

### Python的zipfile答疑
zipfile解压时只会解压成两种编码：
1. utf8
2. cp437

因此如果是非utf8压缩包，一律需要先转码成cp437,之后再转码成本地语言，如gbk
```python
with zipfile.ZipFile(src_project_file_path, 'r') as zipf:
	for file in zipf.filelist:
	file.filename = file.filename.encode('cp437').decode('gbk')
	zipf.extract(file, path)
```